﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Reactive.Linq;
using System.Threading;
using CommunityToolkit.Mvvm.ComponentModel;
using DynamicData;

namespace AvaloniaApplication2.ViewModels;

public partial class MainViewModel : ViewModelBase, IDisposable
{
    public partial class Stuff : ObservableObject
    {
        [ObservableProperty]
        private int _thing = Random.Shared.Next();
    }
    
    [ObservableProperty]
    private ReadOnlyObservableCollection<Stuff> _collection;

    private readonly List<Stuff> _backingList= new(Enumerable.Repeat(new Stuff(), 10).ToList());

    private readonly IDisposable _disposable;
    
    public MainViewModel()
    {
        _disposable = _backingList
            .AsObservableChangeSet()
            .Throttle(TimeSpan.FromMilliseconds(250))
            .ObserveOn(SynchronizationContext.Current!)
            .Bind(out _collection)
            .Subscribe();
    }

    public void Dispose()
    {
        _disposable.Dispose();
    }
}